unit U38Hl;  {STARTOVNi CISLO 38}
{U38Hl.pas, U38Tab.pas, P38.dpr}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Plocha: TImage;
    NovaHraButt: TButton;
    Label1: TLabel;
    PocetEdit: TEdit;
    HintLabel: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    CisloLabel: TLabel;
    Skore1: TLabel;
    Label5: TLabel;
    Skore2: TLabel;
    Label7: TLabel;
    Button1: TButton;
    HelpButt: TButton;
    procedure NovaHraButtClick(Sender: TObject);
    procedure PocetEditChange(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PlochaMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PlochaClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure Button1Click(Sender: TObject);
  
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  CisloN: byte;
  HraVBehu: boolean;
  VertikalniCary, HorizontalniCary: array[0..10,0..10] of boolean;
  soux, souy : integer; {Vyjadruje souradnice cary s kurzorem}
  klavx, klavy: integer; {Souradnice vybrane cary pri vybirani klavesami}
  vertklav, horklav: boolean; {Je true, pokud je klavesami  vybrana prisl. cara}
  horizontalni, vertikalni: boolean; {je true, pokud je mys na takove care}
  cislohrace: byte; {1 nebo 2}
  skore : array[1..2] of integer; {SKORE}
  VybarvenaPole: array[0..9,0..9] of 0..2;
  prazdnapole: integer; {Urcuje, kolik poli je jeste prazdnych}
    
implementation

uses U38Tab;

{$R *.DFM}
(*
procedure VyberTah(var vert: boolean; var sx,sy: byte);
var x,y,j,i: byte; {Pomocne souradnice}
    bodu, maxbodu: integer;
begin
  x := 0; y :=0; maxbodu:=0;
  for i:=0 to CisloN-1 do
    for j:=0 to CisloN do begin
      bodu:=0;
      if not(VertikalniCary[i,j]) then begin
        if (i>0) and VertikalniCary[i-1,j] {Je plna jeste vedle}
         and HorizontalniCary[i-1,j] and HorizontalniCary[i-1,j+1]
        then // !!!!!!!!!! ZISKAL BYCH BOD
         inc(bodu) ;
        if (i<CisloN) and VertikalniCary[i+1,j] {Jeste na druhe strane}
       and HorizontalniCary[i, j] and HorizontalniCary[i, j+1]
       then // !!!!!!!!! BOD
         inc(bodu);
      end;
      if bodu>maxbodu then begin
        maxbodu:=bodu; x:=i; y:=j; vert:=true;
      end;
    end;
  for i:=0 to CisloN do
    for j:=0 to CisloN-1 do begin
      bodu:=0;
      if not(HorizontalniCary[i,j]) then begin
        if (j>0) and HorizontalniCary[i, j-1] {Nad ni je taky}
        and VertikalniCary[i, j-1] and vertikalniCary[i+1, j-1]
        then  //!!!!!!!! BOD
          inc(bodu);
        if (j<CIsloN) and HorizontalniCary[i, j+1] {Pod ni}
       and Vertikalnicary[i, j] and VertikalniCary[i+1,j]
       then inc(bodu);  //!!!!!!!!!!!!!BOD
      end;
      if bodu>maxbodu then begin
        maxbodu:=bodu; x:=i; y:=j;  vert:=false;
      end;
    end;
  if maxbodu=0 then begin
    randomize;
    repeat
      if random(2)=1 then vert:=true else vert:=false;
      if vert then begin
        x:=random(CisloN+1);
        y:=random(cisloN);
      end else begin
        x:=random(CisloN);
        y:=random(CisloN+1);
      end;
    until (vert and not(VertikalniCary[x,y]) or (not(vert) and not(HorizontalniCary[x,y]));
  end;
    sx:=x; sy:=y;
  end;
end; *)

procedure TForm1.NovaHraButtClick(Sender: TObject);
var i,j: byte;  {NASTAVI PODMINKY PRO ZACATEK HRY}
begin
  for i:=0 to 10 do
    for j:=0 to 10 do begin
     VertikalniCary[i,j] := false;  {Na zacatku nejsou zadne cary obsazeny}
     HorizontalniCary[i,j]:=false;
  end;
  for i:=0 to 9 do for j:=0 to 9 do VybarvenaPole[i,j]:=0; {Inicializace}
  skore[1]:=0; skore[2]:=0;
  cisloN:= StrToInt(PocetEdit.text); {Kontrolu porvadi primo PocetEdit}
  HravBehu := true;
  horizontalni:=false; vertikalni:=false; {Mys zatim nan nic neukayuje}
  NovaHraButt.enabled := false;
  pocetedit.enabled:=false;
  label2.visible:=true;
  {helpbutt.enabled:=true;}
  cislohrace:=1;
  HintLabel.caption := 'Hra zaala. Nyn mete thnout kliknutm na sirku.';
  plocha.canvas.brush.color := clWhite;
  plocha.canvas.FillRect(rect(0,0,490,490)); {Vyplneni pole bilou barvou}
  klavx:=0; klavy:=0; horklav:=true; vertklav:=false;  {Inicializace vyberu klavesnici}
  prazdnapole:=cisloN*cisloN;
  form1.Paint; {Musi se vykreslit prazdne pole}
end;

procedure VymenHrace; {Vymeni hrace - kdyz je 1, nastavi 2 a naopak}
begin
  if cislohrace=1 then cislohrace:=2 else cislohrace:=1;
  form1.cislolabel.Caption := inttostr(cislohrace);
  if cislohrace=1 then form1.cislolabel.font.Color := clBlue else
    form1.cislolabel.font.color := clGreen;
end;

procedure TForm1.PocetEditChange(Sender: TObject); {Kontroluje vstup}
var vstup,code: integer;
begin
  val(pocetedit.text, vstup, code); {Prevedeni textu v editacnim poli na cislo}
  if (code>0) {neni tam cislo}
  or not(vstup in [2..10]) then {Tlacitko bude fungovat pouze, kdyz je platny vstup}
    NovaHraButt.Enabled := false else NovaHraButt.enabled:=true;
end;

procedure NakresliVyber(const smaz: boolean); {Kresli elipsu vyberu}
var x,y: integer;
begin
  if smaz then begin
  form1.plocha.canvas.brush.color:=clWhite;
  form1.Plocha.canvas.pen.color:=clWhite;
  end else begin
  form1.plocha.canvas.brush.color:=clRed;
  form1.plocha.canvas.pen.color:=clred;
  end;
  x:=30 + klavx*40; y:=30 + klavy*40;
  if vertklav then
    form1.plocha.canvas.ellipse(x+5, y+10, x+10, y+20)
  else if horklav then
   form1.plocha.canvas.ellipse(x+10,y+5, x+20,y+10);
end;

procedure TForm1.FormPaint(Sender: TObject); {VYKRESLI POLE}
var x,y: integer; {Souradnice pro kresleni pole}
    i,j: byte; {Pomocna promenna}
begin
  if HravBehu then begin
    plocha.canvas.pen.color := clBlack;
    for i:= 0 to CisloN-1 do  {Kresleni horizontalnich car}
      for j:=0 to cisloN do begin
        if HorizontalniCary[i,j] then {Seda barva pro prazdnou, zluta pro plnou}
          plocha.canvas.brush.Color := clYellow else plocha.canvas.brush.color := clGray;
        x:= 30 +i*40; y:=30+j*40;
        plocha.canvas.FillRect(rect(x+5,y,x+40,y+5));
      end;
    for i:= 0 to CisloN do     {Kresleni vert. car}
      for j:= 0 to CisloN-1 do begin
        if VertikalniCary[i,j] then
          plocha.canvas.brush.Color := clYellow else plocha.canvas.brush.color := clGray;
        x:= 30 +i*40; y:=30+j*40;
        plocha.canvas.fillrect(rect(x,y+5,x+5,y+40));
      end;
    for i:=0 to CisloN-1 do   {Vybarvovani ziskanych policek}
      for j:=0 to CisloN-1 do
        if VybarvenaPole[i,j]>0 then begin
          if VybarvenaPole[i,j]=1 then
            plocha.canvas.brush.color:=clBlue else plocha.canvas.brush.color:=clGreen;
          x:= 30 + i*40; y:=30+j*40;
          plocha.canvas.fillrect(rect(x+10,y+10, x+35,y+35));
        end;
    NakresliVyber(false);           {Elipsa klavesoveho vyberu}
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   HraVBehu := false;

end;

procedure TForm1.PlochaMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);  {Zjisti, zda mys neni nad sirkou, a meni kurzor odp.zpusobem}
var pomxmod, pomxdiv, pomymod, pomydiv: integer;
begin
  {if nastavujeklavesami then begin
   nastavujeKlavesami := false;
    NakresliVyber(true);
    vertklav:=false; horklav:=false;
  end; }
  pomxmod := (x - 30) mod 40;
  pomxdiv := (x - 30) div 40;
  pomymod := (y - 30) mod 40;
  pomydiv := (y - 30) div 40;
  if (pomxmod in [5..40]) {Kdyz je x-ova na nejake podelne}
    and (pomxdiv in [0..CisloN-1]) {a neni na neexistujici}
    and (pomymod in [0..5]) {y-ova je taky na podelne}
    and (pomydiv in [0..CisloN]) then
      begin  {Ano, je na nejake horizontalni}
        Plocha.Cursor := crHandPoint;
        soux := pomxdiv; souy:=pomydiv;
        horizontalni:=true; vertikalni := false;
      end else begin {Neni na vertikalni?}
    if (pomxmod in [0..5]) and (pomxdiv in [0..CisloN]) and
    (pomymod in [5..40]) and (pomydiv in [0..CisloN-1]) then
    begin                       {Je na vertikalni}
      Plocha.cursor := crHandPoint;
      soux := pomxdiv; souy:=pomydiv;
      horizontalni :=false; vertikalni:=true;
      end
      else begin
        plocha.cursor := crDefault;
        horizontalni:=false; vertikalni:=false;
      end;
      {Kdyz je, nastavi se kurzor jako ruka, jinak je normalni}
  end;
end;

procedure KonecHry;
var jmeno: string;
    zobrazitTOPTEN: boolean;
begin
  zobrazittopten:=false;
  if skore[1]>= minskore then begin
    jmeno := inputbox('GRATULUJI!', 'Hr slo 1 zskal rekordn poet bod. Zadejte jmno:', '1');
    pridejHrace(Jmeno, skore[1]);
    zobrazittopten:=true;
  end;
  if skore[2]>= minskore then begin
    jmeno := inputbox('GRATULUJI!', 'Hr slo 2 zskal rekordn poet bod. Zadejte jmno:', '2');
    pridejhrace(jmeno, skore[2]);
    zobrazittopten:=true;
  end;
  form1.pocetedit.enabled:= true;
  form1.novahrabutt.enabled:=true;
  form1.helpbutt.Enabled := false;
  form1.HintLabel.caption := 'Hra skonila. Nyn mete zat novou kliknutm na tlatko Nav hra.';
  if zobrazittopten then form2.showmodal;
end;

procedure TForm1.PlochaClick(Sender: TObject);
var provedltah, ziskalbod: boolean;
begin
 provedltah:=false;
 ziskalbod:=false;
  if horizontalni then begin
    if HorizontalniCary[soux, souy] then
      HintLabel.caption := 'Bohuel, klikli jste na obsazen msto. Zkuste kliknout na ed polko.'
    else begin
      HorizontalniCary[soux,souy]:=true; form1.paint; {**** TAH ****}
      provedltah:=true;
    end;
  end else if vertikalni then begin
    if VertikalniCary[soux, souy] then
      HintLabel.caption := 'Bohuel, klikli jste na obsazen msto. Zkuste kliknout na ed polko.'
    else begin {********** TAH ******}
      VertikalniCary[soux, souy] :=true; form1.paint;
      provedltah:=true;
    end;
  end else HintLabel.caption := 'Provete tah tak, e kliknete na edou ru.';
  if provedltah then begin
    if vertikalni then begin  // Pridala se vertikalni cara
      if (soux>0) and VertikalniCary[soux-1, souy] {Je plna jeste vedle}
       and HorizontalniCary[soux-1,souy] and HorizontalniCary[soux-1,souy+1]
       then begin // !!!!!!!!!! ZISKA BOD
         ziskalbod:=true;
         dec(prazdnapole);
         inc(skore[cislohrace]);
         VybarvenaPole[soux-1, souy]:=cislohrace;
       end;
      if (soux<CisloN) and VertikalniCary[soux+1,souy] {Jeste na druhe strane}
       and HorizontalniCary[soux, souy] and HorizontalniCary[soux, souy+1]
       then begin // !!!!!!!!! BOD
         dec(prazdnapole);
         ziskalbod:=true;
         inc(skore[cislohrace]);
         VybarvenaPole[soux, souy]:=cislohrace;
       end;
    end else begin             // Pridala se horizontalni
      if (souy>0) and HorizontalniCary[soux, souy-1] {Nad ni je taky}
       and VertikalniCary[soux, souy-1] and vertikalniCary[soux+1, souy-1]
       then begin //!!!!!!!! BOD
         ziskalbod:=true; dec(prazdnapole);
         inc(skore[cislohrace]);
         VybarvenaPole[soux, souy-1]:=cislohrace;
       end;
      if (souy<CIsloN) and HorizontalniCary[soux, souy+1] {Pod ni}
       and Vertikalnicary[soux, souy] and VertikalniCary[soux+1,souy]
       then begin  //!!!!!!!!!!!!!BOD
         ziskalbod:=true;  dec(prazdnapole);
         inc(skore[cislohrace]);
         VybarvenaPole[soux, souy]:=cislohrace;
       end;
    end;
    if ziskalbod then begin
      form1.paint;
      skore1.Caption := inttostr(skore[1]);
      skore2.caption := inttostr(skore[2]);
      if prazdnapole=0 then Konechry;
    end else VymenHrace;
  end;
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
var provedltah, ziskalbod :boolean;
begin
  {if NastavujeKlavesami then begin}
    provedltah:=false;  ziskalbod:=false;
    NakresliVyber(true);
    if key='4' {doleva} then begin
      if klavx>0 then dec(klavx) else beep;
    end ;
    if key='6' {doprava} then begin
      if (vertklav and (klavx<CisloN)) or (horklav and (klavx<(cisloN-1))) then
        inc(klavx) else beep;
    end;
    if key = '8' {Nahoru} then begin
      if vertklav then begin  {je vybrana vetikalni}
        if klavx=CisloN then klavx:=CisloN-1;
        vertklav:=false; horklav:=true;
      end else if (klavy>0) then begin  {horizontalni}
        horklav:=false; vertklav:=true; dec(klavy);
      end;
    end;
    if key = '2' {Dolu} then begin
      if vertklav then begin //je vybrana vertikalni
        vertklav:=false; horklav:=true;
        inc(klavy);
      end else if (klavy<CisloN) then begin //horizontalni
        horklav:=false; vertklav:=true;
      end;
    end;
    NakresliVyber(false);
    if key=#13 {Enter} then begin
      if vertklav then begin
        if VertikalniCary[klavx,klavy] then
          HintLabel.caption := 'Bohuel, vybrali jste msto, kde u sirka je.'
        else begin {************* TAH **********}
          Vertikalnicary[klavx,klavy]:=true; form1.paint;
          provedltah:=true;
        end;
      end else begin
        if HorizontalniCary[klavx,klavy] then
          HintLabel.caption := 'Bohuel, vybrali jste msto, kde u sirka je.'
        else begin  { ************* TAH *******}
          HorizontalniCary[klavx,klavy]:= true; form1.paint;
          provedltah:=true;
        end;
      end;
      if provedltah then begin
        if vertklav then begin
          if (klavx>0) and VertikalniCary[klavx-1, klavy] {Je plna jeste vedle}
           and HorizontalniCary[klavx-1,klavy] and HorizontalniCary[klavx-1,klavy+1]
           then begin // !!!!!!!!!! ZISKA BOD
             ziskalbod:=true;  dec(prazdnapole);
             inc(skore[cislohrace]);
             VybarvenaPole[klavx-1, klavy]:=cislohrace;
           end;
          if (klavx<CisloN) and VertikalniCary[klavx+1,klavy] {Jeste na druhe strane}
           and HorizontalniCary[klavx, klavy] and HorizontalniCary[klavx, klavy+1]
           then begin // !!!!!!!!! BOD
             ziskalbod:=true;  dec(prazdnapole);
             inc(skore[cislohrace]);
             VybarvenaPole[klavx, klavy]:=cislohrace;
           end;
        end else begin
          if (klavy>0) and HorizontalniCary[klavx, klavy-1] {Nad ni je taky}
          and VertikalniCary[klavx, klavy-1] and vertikalniCary[klavx+1, klavy-1]
          then begin //!!!!!!!! BOD
            ziskalbod:=true; dec(prazdnapole);
            inc(skore[cislohrace]);
            VybarvenaPole[klavx, klavy-1]:=cislohrace;
          end;
          if (klavy<CIsloN) and HorizontalniCary[klavx, klavy+1] {Pod ni}
          and Vertikalnicary[klavx, klavy] and VertikalniCary[klavx+1,klavy]
          then begin  //!!!!!!!!!!!!!BOD
            ziskalbod:=true; dec(prazdnapole);
            inc(skore[cislohrace]);
            VybarvenaPole[klavx, klavy]:=cislohrace;
          end;
        end;
        if ziskalbod then begin
          form1.paint;
          skore1.Caption := inttostr(skore[1]);
          skore2.caption := inttostr(skore[2]);
          if prazdnapole=0 then Konechry;
        end else VymenHrace;
      end;
    end;
  (*end else begin
    NastavujeKlavesami:=true;
    klavx:=0; klavy:=0; horklav:=true; vertklav:=false;
    NakresliVyber(false);   {Vykresleni elipsy, ktera znaci vyber}
  end;  *)
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  form2.showmodal;
end;

{procedure TForm1.HelpButtClick(Sender: TObject);
var x,y: byte; vert: boolean;
    key: char;
begin
  VyberTah(vert, x, y);
  NakresliVyber(true);
  if vert then begin
    vertklav:=true;
    horklav:=false;
  end else begin
    vertklav:=false;
    horklav:=true;
  end;
  klavx:=x; klavy:=y;
  key:=#13;
  FormKeyPress(Sender, key);
end; }

end.
